module user.doob_test1.draw;

private import dwt.DWT;
private import dwt.events.SelectionListener;
private import dwt.events.SelectionEvent;
private import dwt.layout.FillLayout;
private import dwt.widgets.Canvas;
private import dwt.widgets.Control;
private import dwt.widgets.Display;
private import dwt.widgets.Shell;
private import dwt.events.PaintListener;
private import dwt.events.MouseListener;
private import dwt.events.MouseMoveListener;

private import tango.io.Stdout;

private import user.doob_test1.MouseHandler;
private import user.doob_test1.PaintHandler;


import tango.io.Stdout;
import tango.math.Math;
import tango.text.convert.Format;
import tango.util.Convert;
import tango.util.PathUtil;
import dwt.events.SelectionListener;
import dwt.events.SelectionEvent;

void main(){
    try{
        auto display = new Display();
        auto shell = new Shell(display);

        auto canvas = new Canvas(shell,DWT.NO_REDRAW_RESIZE);
        auto hPaint= new PaintHandler(canvas, display);
        auto hMouse = new MouseHandler(hPaint);

        shell.setText("Draw window");
        shell.setSize(500, 500);
        shell.setLayout(new FillLayout());

        canvas.addPaintListener(hPaint);
        canvas.addMouseListener(hMouse);
        canvas.addMouseMoveListener(hMouse);
        shell.layout();
        shell.open();
        while (!shell.isDisposed()) {
            if (!display.readAndDispatch()) {
                display.sleep();
            }
        }
        Stdout("Stop").newline.flush;
    } catch (Exception e) {
        Stdout.formatln (e.toString);
    }
}